wxWidgets: wxJoystickEvent Class Reference

| Version: 3.2.5

Public Member Functions | List of all members
wxJoystickEvent Class Reference
Class List by Category » Events

`#include <wx/event.h>`

Inheritance diagram for wxJoystickEvent:
[legend]

## Detailed Description

This event class contains information about joystick events, particularly events received by windows.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxJoystickEvent& event)

Event macros:

- EVT_JOY_BUTTON_DOWN(func):
  Process a `wxEVT_JOY_BUTTON_DOWN` event.
- EVT_JOY_BUTTON_UP(func):
  Process a `wxEVT_JOY_BUTTON_UP` event.
- EVT_JOY_MOVE(func):
  Process a `wxEVT_JOY_MOVE` event.
- EVT_JOY_ZMOVE(func):
  Process a `wxEVT_JOY_ZMOVE` event.
- EVT_JOYSTICK_EVENTS(func):
  Processes all joystick events.

##

Library: wxCore
Category: Events

See also
  wxJoystick

## Public Member Functions
| wxJoystickEvent (wxEventType eventType=wxEVT_NULL, int state=0, int joystick=wxJOYSTICK1, int change=0)
| Constructor. More...
bool | ButtonDown (int button=wxJOY_BUTTON_ANY) const
| Returns true if the event was a down event from the specified button (or any button). More...
bool | ButtonIsDown (int button=wxJOY_BUTTON_ANY) const
| Returns true if the specified button (or any button) was in a down state. More...
bool | ButtonUp (int button=wxJOY_BUTTON_ANY) const
| Returns true if the event was an up event from the specified button (or any button). More...
int | GetButtonChange () const
| Returns the identifier of the button changing state. More...
int | GetButtonOrdinal () const
| Returns the 0-indexed ordinal of the button changing state. More...
int | GetButtonState () const
| Returns the down state of the buttons. More...
int | GetJoystick () const
| Returns the identifier of the joystick generating the event - one of wxJOYSTICK1 and wxJOYSTICK2. More...
wxPoint | GetPosition () const
| Returns the x, y position of the joystick event. More...
int | GetZPosition () const
| Returns the z position of the joystick event. More...
bool | IsButton () const
| Returns true if this was a button up or down event (not 'is any button down?'). More...
bool | IsMove () const
| Returns true if this was an x, y move event. More...
bool | IsZMove () const
| Returns true if this was a z move event. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxJoystickEvent()

wxJoystickEvent::wxJoystickEvent | ( | wxEventType | eventType = `wxEVT_NULL`,
|  | int | state = `0`,
|  | int | joystick = `wxJOYSTICK1`,
|  | int | change = `0`
| ) |  |

Constructor.

## Member Function Documentation

## ◆ ButtonDown()

bool wxJoystickEvent::ButtonDown | ( | int | button = `wxJOY_BUTTON_ANY` | ) | const

Returns true if the event was a down event from the specified button (or any button).

Parameters

  button | Can be `wxJOY_BUTTONn` where `n` is 1, 2, 3 or 4; or `wxJOY_BUTTON_ANY` to indicate any button down event.

## ◆ ButtonIsDown()

bool wxJoystickEvent::ButtonIsDown | ( | int | button = `wxJOY_BUTTON_ANY` | ) | const

Returns true if the specified button (or any button) was in a down state.

Parameters

  button | Can be `wxJOY_BUTTONn` where `n` is 1, 2, 3 or 4; or `wxJOY_BUTTON_ANY` to indicate any button down event.

## ◆ ButtonUp()

bool wxJoystickEvent::ButtonUp | ( | int | button = `wxJOY_BUTTON_ANY` | ) | const

Returns true if the event was an up event from the specified button (or any button).

Parameters

  button | Can be `wxJOY_BUTTONn` where `n` is 1, 2, 3 or 4; or `wxJOY_BUTTON_ANY` to indicate any button down event.

## ◆ GetButtonChange()

int wxJoystickEvent::GetButtonChange | ( |  | ) | const

Returns the identifier of the button changing state.

The return value is

1 << n

where `n` is the index of the button changing state, which can also be retrieved using GetButtonOrdinal().

Note that for `n` equal to 1, 2, 3 or 4 there are predefined `wxJOY_BUTTONn` constants which can be used for more clarity, however these constants are not defined for the buttons beyond the first four.

## ◆ GetButtonOrdinal()

int wxJoystickEvent::GetButtonOrdinal | ( |  | ) | const

Returns the 0-indexed ordinal of the button changing state.

See also
  GetButtonChange()

Since
  3.1.2.

## ◆ GetButtonState()

int wxJoystickEvent::GetButtonState | ( |  | ) | const

Returns the down state of the buttons.

This is a `wxJOY_BUTTONn` identifier, where `n` is one of 1, 2, 3, 4.

## ◆ GetJoystick()

int wxJoystickEvent::GetJoystick | ( |  | ) | const

Returns the identifier of the joystick generating the event - one of wxJOYSTICK1 and wxJOYSTICK2.

## ◆ GetPosition()

wxPoint wxJoystickEvent::GetPosition | ( |  | ) | const

Returns the x, y position of the joystick event.

These coordinates are valid for all the events except wxEVT_JOY_ZMOVE.

## ◆ GetZPosition()

int wxJoystickEvent::GetZPosition | ( |  | ) | const

Returns the z position of the joystick event.

This method can only be used for wxEVT_JOY_ZMOVE events.

## ◆ IsButton()

bool wxJoystickEvent::IsButton | ( |  | ) | const

Returns true if this was a button up or down event (not 'is any button down?').

## ◆ IsMove()

bool wxJoystickEvent::IsMove | ( |  | ) | const

Returns true if this was an x, y move event.

## ◆ IsZMove()

bool wxJoystickEvent::IsZMove | ( |  | ) | const

Returns true if this was a z move event.